VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Newton's Method"
   ClientHeight    =   2100
   ClientLeft      =   1020
   ClientTop       =   1995
   ClientWidth     =   2355
   DrawMode        =   6  'Mask Pen Not
   LinkTopic       =   "Form1"
   MousePointer    =   2  'Cross
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   140
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   157
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuScale 
      Caption         =   "&Scale"
      Begin VB.Menu mnuSetScale 
         Caption         =   "x &2"
         Index           =   1
      End
      Begin VB.Menu mnuSetScale 
         Caption         =   "x &4"
         Index           =   2
      End
      Begin VB.Menu mnuSetScale 
         Caption         =   "x &8"
         Index           =   3
      End
      Begin VB.Menu mnuScaleFull 
         Caption         =   "&Full"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PI As Double = 3.14159265

Private VisibleXmin As Single
Private VisibleXmax As Single
Private VisibleYmin As Single
Private VisibleYmax As Single
Private Xmin As Single
Private Xmax As Single
Private Ymin As Single
Private Ymax As Single

' Used for zooming.
Private DrawingBox As Boolean
Private StartX As Single
Private StartY As Single
Private CurX As Single
Private CurY As Single

Private Const NUM_ROOTS As Integer = 7
Private m_Roots(NUM_ROOTS) As Complex
Private m_Colors(0 To 9) As Long
' *********************************************
' Increase the area shown by a factor of fact.
' *********************************************
Private Sub ScaleFactor(fact As Integer)
Dim size As Single
Dim mid As Single

    size = fact * (Xmax - Xmin)
    If size > 3.2 Then
        ScaleFull
        Exit Sub
    End If
    mid = (Xmin + Xmax) / 2
    Xmin = mid - size / 2
    Xmax = mid + size / 2
    
    size = fact * (Ymax - Ymin)
    If size > 2.4 Then
        ScaleFull
        Exit Sub
    End If
    mid = (Ymin + Ymax) / 2
    Ymin = mid - size / 2
    Ymax = mid + size / 2
    
    DrawFractal
End Sub

Private Sub Form_Load()
Dim i As Integer

    ' Initialize the roots.
    For i = 0 To NUM_ROOTS - 1
        Set m_Roots(i) = NewComplex( _
            Cos(2 * i * PI / NUM_ROOTS), _
            Sin(2 * i * PI / NUM_ROOTS))
    Next i

    ' Initialize the colors.
    ' Black = exceeded MAX_ITER iterations.
    ' White = unknown root.
    m_Colors(0) = vbBlack
    m_Colors(1) = vbWhite
    m_Colors(2) = vbRed
    m_Colors(3) = &HC000&
    m_Colors(4) = vbBlue
    m_Colors(5) = vbYellow
    m_Colors(6) = &H80C0FF
    m_Colors(7) = vbCyan
    m_Colors(8) = vbMagenta
    m_Colors(9) = vbGreen

    Show
    ScaleFull
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


Private Sub mnuScaleFull_Click()
    ScaleFull
End Sub

' ************************************************
' Start a rubberband box to select a zoom area.
' ************************************************
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    ' See if it's the right button.
    If Button And vbRightButton Then
        ' If we are in the middle of a zoom,
        ' cancel the zoom.
        If DrawingBox Then
            ' Erase the old box.
            Line (StartX, StartY)-(CurX, CurY), , B
            DrawingBox = False
        End If
        Exit Sub
    End If
    
    ' Otherwise start a zoom.
    DrawingBox = True
    StartX = x
    StartY = Y
    CurX = x
    CurY = Y
    Line (StartX, StartY)-(CurX, CurY), , B
End Sub
' ************************************************
' Continue the zoom area rubberband box.
' ************************************************
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    If Not DrawingBox Then Exit Sub

    Line (StartX, StartY)-(CurX, CurY), , B
    CurX = x
    CurY = Y
    Line (StartX, StartY)-(CurX, CurY), , B
End Sub


' ************************************************
' Zoom in on the selected area.
' ************************************************
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
Dim x1 As Single
Dim x2 As Single
Dim y1 As Single
Dim y2 As Single
Dim factor As Single

    If Not DrawingBox Then Exit Sub
    DrawingBox = False
    
    Line (StartX, StartY)-(CurX, CurY), , B
    CurX = x
    CurY = Y
    
    ' Put the coordinates in proper order.
    If CurX < StartX Then
        x1 = CurX
        x2 = StartX
    Else
        x1 = StartX
        x2 = CurX
    End If
    If x1 = x2 Then x2 = x1 + 1
    If CurY < StartY Then
        y1 = CurY
        y2 = StartY
    Else
        y1 = StartY
        y2 = CurY
    End If
    If y1 = y2 Then y2 = y1 + 1

    ' Convert screen coords into drawing coords.
    factor = (Xmax - Xmin) / ScaleWidth
    Xmax = Xmin + x2 * factor
    Xmin = Xmin + x1 * factor

    factor = (Ymax - Ymin) / ScaleHeight
    Ymax = Ymin + y2 * factor
    Ymin = Ymin + y1 * factor

    DrawFractal
End Sub

Private Sub mnuSetScale_Click(Index As Integer)
    Select Case Index
        Case 1
            ScaleFactor 2
        Case 2
            ScaleFactor 4
        Case 3
            ScaleFactor 8
    End Select
End Sub
' ************************************************
' Zoom out to full scale.
' ************************************************
Public Sub ScaleFull()
    Xmin = -1.5
    Xmax = 1.5
    Ymin = -1.5
    Ymax = 1.5

    DrawFractal
End Sub

' ************************************************
' Adjust the aspect ratio of the selected
' coordinates so they fit the window properly.
' ************************************************
Private Sub AdjustAspect()
Dim want_aspect As Single
Dim canvas_aspect As Single
Dim hgt As Single
Dim wid As Single
Dim mid As Single

    want_aspect = (Ymax - Ymin) / (Xmax - Xmin)
    canvas_aspect = ScaleHeight / ScaleWidth
    If want_aspect > canvas_aspect Then
        ' The selected area is too tall and thin.
        ' Make it wider.
        wid = (Ymax - Ymin) / canvas_aspect
        mid = (Xmin + Xmax) / 2
        VisibleXmin = mid - wid / 2
        VisibleXmax = mid + wid / 2
        VisibleYmin = Ymin
        VisibleYmax = Ymax
    Else
        ' The selected area is too short and wide.
        ' Make it taller.
        hgt = (Xmax - Xmin) * canvas_aspect
        mid = (Ymin + Ymax) / 2
        VisibleYmin = mid - hgt / 2
        VisibleYmax = mid + hgt / 2
        VisibleXmin = Xmin
        VisibleXmax = Xmax
    End If
End Sub
' Draw the fractal.
Private Sub DrawFractal()
Const CUTOFF As Single = 0.0000001  ' Work until the epsilon squared < this.
Const MAX_ITER As Integer = 200     ' At most this many iterations.

Dim clr As Integer
Dim x As Complex
Dim x0 As Complex
Dim epsilon As Complex
Dim dx As Double
Dim dy As Double
Dim wid As Double
Dim hgt As Double
Dim iter As Integer
Dim r As Integer
Dim i As Integer
Dim j As Integer

    DrawMode = vbCopyPen
    Line (0, 0)-(ScaleWidth, ScaleHeight), BackColor, BF
    MousePointer = vbHourglass
    DoEvents

    ' Adjust the aspect ratio.
    AdjustAspect

    ' dx is the change in the real part
    ' (X value) for C. dy is the change in the
    ' imaginary part (Y value).
    wid = ScaleWidth
    hgt = ScaleHeight
    dx = (VisibleXmax - VisibleXmin) / (wid - 1)
    dy = (VisibleYmax - VisibleYmin) / (hgt - 1)

    ' Calculate the values.
    Set x0 = NewComplex(Xmin, 0)
    For i = 1 To wid
        x0.Im = Ymin
        For j = 1 To hgt
            Set x = x0
            iter = 0
            Do
                iter = iter + 1
                If iter > MAX_ITER Then Exit Do
                Set epsilon = F(x).DividedBy(dFdx(x)).TimesComponents(-1, 0)
                Set x = x.Plus(epsilon)
            Loop While epsilon.MagnitudeSquared() > CUTOFF

            ' Set which root this is.
            If iter > MAX_ITER Then
                clr = 0 ' Black.
            Else
                ' Find the root.
                clr = 1 ' White.
                For r = 0 To UBound(m_Roots)
                    If x.IsCloseTo(m_Roots(r)) Then
                        clr = r + 2 ' +2 to skip black and white.
                        Exit For
                    End If
                Next r
            End If

            ' Set the pixel's color.
            PSet (i, j), m_Colors(clr)

            ' Move to the next point.
            x0.Im = x0.Im + dy
        Next j
        x0.Re = x0.Re + dx
        DoEvents
    Next i

    Refresh
    Picture = Image

    MousePointer = vbCrosshair
    DrawMode = vbInvert
End Sub
' The function.
' F(x) = x^NUM_ROOTS - 1.
Private Function F(ByVal x As Complex) As Complex
Dim result As Complex
Dim i As Integer

    Set result = x.Clone()   ' x.

    ' x^NUM_ROOTS.
    For i = 1 To NUM_ROOTS - 1
        Set result = result.Times(x)
    Next i

    ' x^NUM_ROOTS - 1.
    Set F = result.PlusComponents(-1, 0)
End Function
' The function's derivative.
' dFdx(x) = NUM_ROOTS * x^(NUM_ROOTS - 1).
Private Function dFdx(ByVal x As Complex) As Complex
Dim result As Complex
Dim i As Integer

    Set result = x.Clone()   ' x.

    ' x^(NUM_ROOTS - 1).
    For i = 1 To NUM_ROOTS - 2
        Set result = result.Times(x)
    Next i

    ' NUM_ROOTS * x^(NUM_ROOTS - 1).
    Set dFdx = result.TimesComponents(NUM_ROOTS, 0)
End Function

